/*
 * Copyright 2016 - 2025 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <studio/undocommand.hpp>

#include <nostalgia/gfx/palette.hpp>

namespace nostalgia::gfx {

class UpdateColorInfoCommand: public studio::UndoCommand {
	private:
		Palette &m_pal;
		size_t const m_idx{};
		ox::String m_altColorInfo;

	public:
		UpdateColorInfoCommand(
				Palette &pal,
				size_t idx,
				ox::StringParam newColorInfo);

		~UpdateColorInfoCommand() noexcept override = default;

		[[nodiscard]]
		bool mergeWith(UndoCommand &cmd) noexcept final;

		[[nodiscard]]
		int commandId() const noexcept final;

		ox::Error redo() noexcept final;

		ox::Error undo() noexcept final;

	private:
		void swap() noexcept;

};

}
